from kubermagic import KubermagicAction, forms


GREETING_CHOICES = (
    'Hello',
    'Goodbye',
)


class GreetingForm(forms.Form):
    name = forms.TextField(placeholder="Your name")
    greeting = forms.DropdownField(choices=GREETING_CHOICES)
    is_exclamation = forms.CheckboxField(label="Add Exclamation", checked=False)


class Action(KubermagicAction):

    def run(self):
        form = GreetingForm()
        self.form_dialog(
            "Greeting Form", "Please select how you would like to be greeted.",
            form, ok_button_text="Greet me", callback=self.greet_callback
        )

    def greet_callback(self, form_data):

        print("Data from form:", form_data)

        greeting = form_data["greeting"]
        name = form_data["name"]
        exclamation = form_data["is_exclamation"]

        output = f"{greeting}, {name} {'!!!' if exclamation else ''}"
        self.ok_dialog("Hello world result.", output, "Why, thank you!")


if __name__ == "__main__":
    action = Action()
    action.test_run()
